using System;
using System.Windows.Forms;
using System.IO;
using System.Diagnostics;

namespace MorrowindPatch {

	public class PatchForm: Form {
	    #region FormDesignerBloat
	/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.IContainer components = null;

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		/// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
		protected override void Dispose(bool disposing)
		{
			if (disposing && (components != null))
			{
				components.Dispose();
			}
			base.Dispose(disposing);
		}

		#region Windows Form Designer generated code

		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.tbPath=new System.Windows.Forms.TextBox();
            this.bBrowse=new System.Windows.Forms.Button();
            this.bCancel=new System.Windows.Forms.Button();
            this.bOK=new System.Windows.Forms.Button();
            this.folderBrowserDialog=new System.Windows.Forms.FolderBrowserDialog();
            this.SuspendLayout();
            // 
            // tbPath
            // 
            this.tbPath.Anchor=((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top|System.Windows.Forms.AnchorStyles.Left)
                        |System.Windows.Forms.AnchorStyles.Right)));
            this.tbPath.Location=new System.Drawing.Point(12,12);
            this.tbPath.Name="tbPath";
            this.tbPath.Size=new System.Drawing.Size(188,20);
            this.tbPath.TabIndex=0;
            // 
            // bBrowse
            // 
            this.bBrowse.Anchor=((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top|System.Windows.Forms.AnchorStyles.Right)));
            this.bBrowse.Location=new System.Drawing.Point(206,12);
            this.bBrowse.Name="bBrowse";
            this.bBrowse.Size=new System.Drawing.Size(75,20);
            this.bBrowse.TabIndex=1;
            this.bBrowse.Text="Browse";
            this.bBrowse.Click+=new System.EventHandler(this.bBrowse_Click);
            // 
            // bCancel
            // 
            this.bCancel.Location=new System.Drawing.Point(12,38);
            this.bCancel.Name="bCancel";
            this.bCancel.Size=new System.Drawing.Size(75,20);
            this.bCancel.TabIndex=2;
            this.bCancel.Text="Cancel";
            this.bCancel.Click+=new System.EventHandler(this.bCancel_Click);
            // 
            // bOK
            // 
            this.bOK.Location=new System.Drawing.Point(93,38);
            this.bOK.Name="bOK";
            this.bOK.Size=new System.Drawing.Size(75,20);
            this.bOK.TabIndex=3;
            this.bOK.Text="OK";
            this.bOK.Click+=new System.EventHandler(this.bOK_Click);
            // 
            // folderBrowserDialog
            // 
            this.folderBrowserDialog.Description="Select root morrowind folder";
            this.folderBrowserDialog.ShowNewFolderButton=false;
            // 
            // PatchForm
            // 
            //this.AutoScaleDimensions=new System.Drawing.SizeF(6F,13F);
            //this.AutoScaleMode=System.Windows.Forms.AutoScaleMode.Font;
            this.ClientSize=new System.Drawing.Size(293,70);
            this.Controls.Add(this.bOK);
            this.Controls.Add(this.bCancel);
            this.Controls.Add(this.bBrowse);
            this.Controls.Add(this.tbPath);
            this.FormBorderStyle=System.Windows.Forms.FormBorderStyle.FixedToolWindow;
            this.Name="PatchForm";
            this.Text="Morrowind 1.7 patch";
            this.ResumeLayout(false);
            this.PerformLayout();

		}

		#endregion

        private System.Windows.Forms.TextBox tbPath;
        private System.Windows.Forms.Button bBrowse;
        private System.Windows.Forms.Button bCancel;
        private System.Windows.Forms.Button bOK;
        private System.Windows.Forms.FolderBrowserDialog folderBrowserDialog;
#endregion

		public PatchForm(string InitPath)
		{
			InitializeComponent();
            tbPath.Text=InitPath;
		}

        private void bCancel_Click(object sender,EventArgs e) {
            Close();
        }

        private void bBrowse_Click(object sender,EventArgs e) {
            if(folderBrowserDialog.ShowDialog()==DialogResult.OK) {
                tbPath.Text=folderBrowserDialog.SelectedPath;
            }
        }

        private void bOK_Click(object sender,EventArgs e) {
            string s=tbPath.Text;
            try {
                if(!Directory.Exists(s)) throw new Exception();
            } catch {
                MessageBox.Show("Illegal directory selected");
                return;
            }
            if(!File.Exists(s+"\\Morrowind.exe")) {
                MessageBox.Show("Morrowind is not installed in that directory","Error");
                return;
            }
            if(File.Exists(s+"\\Morrowind.exe.upb")) {
                MessageBox.Show("Could not create backup file; file already exists","Error");
                return;
            }
            FileVersionInfo fvi=FileVersionInfo.GetVersionInfo(s+"\\Morrowind.exe");
            if(fvi.FileMinorPart!=6) {
                MessageBox.Show("This patch requires morrowind 1.6","Error");
                return;
            }
            try {
                File.Copy(s+"\\Morrowind.exe",s+"\\Morrowind.exe.upb");
                BinaryWriter bw=new BinaryWriter(File.Open(s+"\\Morrowind.exe",FileMode.Open));
                foreach(Patch p in Program.patches) {
                    bw.Seek((int)(p.StartPos-8),SeekOrigin.Begin);
                    for(int i=0;i<p.Code.Length;i++) {
                        bw.Write(p.Code[i]);
                    }
                }
                bw.Close();
            } catch {
                MessageBox.Show("Error applying patch","Error");
                return;
            }
            MessageBox.Show("Patch sucessfully applied","Done");
            Close();
        }
    }
}
