//#define CREATE
using System;
using System.Windows.Forms;
using Formatter=System.Runtime.Serialization.Formatters.Binary.BinaryFormatter;
using ArrayList=System.Collections.ArrayList;
using Microsoft.Win32;
#if CREATE
using System.IO;
#else
using System.Resources;
#endif

namespace MorrowindPatch {
    [Serializable]
    public struct Patch {
        public long StartPos;
        public long[] Code;
    }

	public class Program {
        public static Formatter formatter=new Formatter();
        public static ArrayList patches=new ArrayList();

		[STAThread]
		static void Main() {
            #if CREATE
            CreatePatch();
            #else
            try {
                patches=(ArrayList)formatter.Deserialize(PatchCode.GetData());
            } catch {
                MessageBox.Show("Error extracting patch","Error");
                return;
            }
            RegistryKey rk=Registry.LocalMachine.OpenSubKey("Software\\Bethesda softworks\\morrowind");
            string mPath=(string)rk.GetValue("Installed Path",null);
            if(mPath==null) mPath="";
            PatchForm pf=new PatchForm(mPath);
			Application.Run(pf);
            #endif
		}

        #if CREATE
        public static Patch CreatePatch(long pos,ArrayList code) {
            Patch p=new Patch();
            p.StartPos=pos;
            p.Code=(long[])code.ToArray(typeof(long));
            return p;
        }

        public static void CreatePatch() {
            ArrayList list=new ArrayList();
            long Temp1;
            long Temp2;
            bool Found=false;
            long StartPos=0;
            BinaryReader patched=new BinaryReader(File.OpenRead(@"C:\games\morrowind\morrowind.exe"));
            BinaryReader unpatched=new BinaryReader(File.OpenRead(@"C:\games\morrowind\morrowind.exe.fpu2ssebak"));
            while(patched.BaseStream.Position<patched.BaseStream.Length) {
                Temp1=patched.ReadInt64();
                Temp2=unpatched.ReadInt64();
                if(Found) {
                    if(Temp1!=Temp2) {
                        list.Add(Temp1);
                    } else {
                        patches.Add(CreatePatch(StartPos,list));
                        list.Clear();
                        Found=false;
                    }
                } else {
                    if(Temp1!=Temp2) {
                        Found=true;
                        list.Add(Temp1);
                        StartPos=patched.BaseStream.Position;
                    }
                }
            }
            patched.Close();
            unpatched.Close();
            MemoryStream ms=new MemoryStream(); ;
            formatter.Serialize(ms,patches);
            ms.Position=0;
            StreamWriter sw=new StreamWriter("patch.cs");
            sw.WriteLine("using System;");
            sw.WriteLine("using System.IO;");
            sw.WriteLine("namespace MorrowindPatch {");
            sw.WriteLine("public class PatchCode {");
            sw.WriteLine("public static MemoryStream GetData() {");
            sw.WriteLine("return new MemoryStream(new byte[] {");
            for(int i=0;i<ms.Length;i++) {
                if(i%500==0) sw.WriteLine();
                sw.Write(ms.ReadByte().ToString()+",");
            }
            sw.WriteLine("});");
            sw.WriteLine("}");
            sw.WriteLine("}");
            sw.WriteLine("}");
            ms.Close();
            sw.Close();
        }
        #endif

    }
}
